'.---------+-----------+-------- [DynUpdate] --------+--------------------:
'|                    FTPD Search System v2.3.3 by TuS                    |
':---------+-----------+----------+-----------------+---------------------:

'**************************************************************************
'* Copyright (C) 2011                                                     *
'* TuS, tustus[at]hotmail[dot]com                                         *
'*                                                                        *
'* This program is free software; you can redistribute it and/or modify   *
'* it under the terms of the GNU General Public License as published by   *
'* the Free Software Foundation; either version 2 of the License, or      *
'* (at your option) any later version.                                    *
'*                                                                        *
'* This program is distributed in the hope that it will be useful, but    *
'* WITHOUT ANY WARRANTY; without even the implied warranty of             *
'* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                   *
'* See the GNU General Public License for more details.                   *
'*                                                                        *
'* You should have received a copy of the GNU General Public License      *
'* along with this program; if not, write to the                          *
'* Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,    *
'* MA 02111-1307 USA                                                      *
'**************************************************************************
'**************************************************************************
'* VBS Script logging Framework :                                         *
'* Copyright (C) 2006                                                     *
'* Christer Finsen, mind[underscore]trip[at]users[dot]sourceforge[dot]net *
'* Nils-Erik Aurker, nils-erik[at]users[dot]sourceforge[dot]net          *
'**************************************************************************

Option Explicit

'Import Configuration
Import ("Search.Config")

If CONVERT = "" Or REPLACEVFS = "" Or EVENTLOG = "" Or FILELOG = "" Or LOGS = "" _
Or LOCATE = "" Or UPDATEDB = "" Or HSTART= "" Or OUTPUT = "" Or VFS = "" _
Or RESULTDEF = "" Or RESULTMAX = "" Or SEARCHTYPE = "" _
Or TypeName(ENABLEHSTART) <> "Boolean" Or TypeName(SCENEVIEW) <> "Boolean" Or TypeName(WIDTH) <> "Integer" _
Or TypeName(SCENEHEADER) <> "String" Or TypeName(SCENESEPARATOR) <> "String" Or TypeName(SCENETAIL) <> "String" _
Or TypeName(NORMALHEADER) <> "String" Or TypeName(NORMALSEPARATOR) <> "String" Or TypeName(NORMALTAIL) <> "String" _
Or TypeName(EXCLUDEDVFS) <> "String" Or TypeName(ALLOWEDVFS) <> "String" Or TypeName(CHILDLIST) <> "String" Then
  wscript.echo "One or more required constants is not defined. Please see readme.txt for installation"
  wscript.quit
End If
  
'***************************************************************************************************************************
'                                          CUSTOMIZABLE CONSTANTS
'***************************************************************************************************************************
'See UpdateDB.Config


'***************************************************************************************************************************
'                      DO NOT CHANGE THESE CONSTANTS UNLESS YOU KNOW WHAT YOU ARE DOING
'***************************************************************************************************************************
Const APPNAME       = "FTPD Search System"
Const APPVERMAJOR   = "2"
Const APPVERMINOR   = "3.3 (By TuS)"
Const FORREADING    = 1
Const FORWRITING    = 2
Const FORAPPENDING  = 8
Const SUCCESS       = 0
Const ERRORL        = 1
Const WARNING       = 2
Const INFORMATION   = 4
Const ABORT         = "Script aborted with error(s). To determine cause, see logged information"
Const SITECMD       = "dyndb"

'Script Root folder
Dim SCRIPTPATH : SCRIPTPATH = Left(WScript.ScriptFullName, InStrRev(WScript.ScriptFullName,"\")-1)
Dim SCRIPTNAME : SCRIPTNAME = Left(WScript.ScriptName, InStrRev(WScript.ScriptName,".")-1)

Dim aLog,aIndex()
Dim bLog
Dim cFiles
Dim i,iCnt
Dim oFile,oFldr,oFso,oRegEx,oShell,oOut,sOutput
Dim sDBRoot,sLine,sLog,sLogRoot,sUser
Dim oArgs
Dim sGCID,sCmd,sTarget,sTargetParent,sTargetVFS,sTargetFolder
Dim bAllowed,sAllowed,aAllowed,bChild,sChild,aChildList

'Create Shell object
Set oShell = Wscript.CreateObject("Wscript.Shell")

s_Log SUCCESS, "[Main Code] " & APPNAME & " " & APPVERMAJOR & "." & APPVERMINOR & " started successfully"

'Create FileSystemObject
Set oFso = CreateObject("Scripting.FileSystemObject")

'Assign path to root of log
sLogRoot = SCRIPTPATH & "\DBLog"

'Check presens of sLogRoot, abort if it doesn't exists and can't be created
s_Log INFORMATION, "[Main Code] Call f_CreateFolder, " & sLogRoot
If f_CreateFolder(sLogRoot) <> True Then
	s_Log ERRORL, ABORT
	wscript.quit
End If

'Set name of logfile
sLog = sLogRoot & "\" & f_GetDayTimeDate() & ".log"
If (oFso.FileExists(sLog)) Then
  s_Log INFORMATION, "[Main Code] The logfile : " & sLog & " allready exists. Appending random number to name of logfile"
  sLog = sLogRoot & "\" & f_GetDayTimeDate() & "_" & f_Randomize(9999) & ".log"
End If
s_Log INFORMATION, "[Main Code] Logfile = " & sLog

'Turning on filelog
bLog = True

'Check presens of important files
f_FileExists UPDATEDB, True
f_FileExists VFS, True
If ENABLEHSTART Then
 f_FileExists HSTART, True
End If 

'Assign path to root of DB
sDBRoot = SCRIPTPATH & "\DB"

s_Log INFORMATION, "[Main Code] Database root = " & sDBRoot

'Check presence of sDBRoot, abort if it doesn't exists and can't be created
s_Log INFORMATION, "[Main Code] Call f_CreateFolder, " & sDBRoot
If f_CreateFolder(sDBRoot) <> True Then
	s_Log ERRORL, ABORT
	wscript.quit
End If

'Assign path FTPD Output dir
sOutPut = OUTPUT

'Check presence of sOutPut, abort if it doesn't exists and can't be created
s_Log INFORMATION, "[Main Code] Call f_CreateFolder, " & sOutPut
If f_CreateFolder(sOutPut) <> True Then
	s_Log ERRORL, ABORT
	wscript.quit
End If

'Get path which Locate32 should index
s_GetPathToIndexFromVFS VFS

'Bind to arguments
Set oArgs = wscript.Arguments

'Make sure that only expected number of arguments are sent
If oArgs.Count <> 4 Then
s_Log ERRORL, "[Main Code] FTPD or this installation has been tamper with. Expected number of arguments : 4, found : " & oArgs.Count
s_DelLog()
WScript.quit
End If

s_Log SUCCESS, "[Main Code] A DynDB update of system search databases was triggered on file upload: " & oArgs(2)

For i = 0 To oArgs.Count -1
s_Log INFORMATION, "[Main Code] Argument#" & i & ",Value=" & oArgs(i)
Next

'Assign Global Unique Client ID from argument 0
sGCID = oArgs(0)
s_Log INFORMATION, "[Main Code] sGCID=" & sGCID

sCmd = oArgs(1)
s_Log INFORMATION, "[Main Code] sCmd=" & sCmd

sTarget = Left(oArgs(2), InStrRev(oArgs(2),"\")-1)
s_Log INFORMATION, "[Main Code] sTarget=" & sTarget

sTargetParent = Left(sTarget, InStrRev(sTarget,"\")-1)
sTargetFolder = Right(sTarget, Len(sTarget) - InStrRev(sTarget,"\"))

sTargetVFS = Left(oArgs(3), InStrRev(oArgs(3),"/")-1)
s_Log INFORMATION, "[Main Code] sTargetVFS=" & sTargetVFS

If f_VerifyCmd(sCmd) Then
	s_Log SUCCESS, "[Main Code] Input verified successfully, commiting update of databases."
Else
	s_Log ERRORL, "[Main Code] Error. Databases will NOT be updated."
End If

'Check Allowed Paths 
bAllowed = False
If InStr(ALLOWEDVFS, "|") <> 0 Then
	aAllowed = Split(ALLOWEDVFS,"|")
		For Each sAllowed In aAllowed
			If (InStr(LCase(Left(sTargetVFS,Len(sAllowed))), LCase(sAllowed)) And (sAllowed <> vbNullString))  Then
				bAllowed = True
				Exit For  
			End If
		Next
Else
	sAllowed = ALLOWEDVFS
	If (InStr(LCase(sTargetVFS), LCase(sAllowed)) And (sAllowed <> vbNullString)) Then
		bAllowed = True
	End If
End if

If bAllowed Then
	s_Log INFORMATION, "[Main Code] Allowed VFS: " & sTargetVFS
	'process Childlist list
	bChild = False
	If InStr(CHILDLIST, "|") <> 0 Then
		aChildList = Split(CHILDLIST,"|")
			For Each sChild In aChildList
				If (StrComp(LCase(sTargetFolder),LCase(sChild)) = 0 And (sChild <> vbNullString))  Then
					bChild = True 
					Exit For  
				End If
			Next
	Else
		sChild = CHILDLIST
		If (StrComp(LCase(sTargetFolder),LCase(sChild)) = 0 And (sChild <> vbNullString))  Then
			bChild = True 
		End If
	End if

	'Process DynDB
	If bChild Then
		s_CreateDynDB Left(sTargetParent, InStrRev(sTargetParent,"\")-1), Right(sTargetParent,Len(sTargetParent)-InStrRev(sTargetParent,"\"))
	Else
		s_CreateDynDB sTargetParent, Right(sTarget,Len(sTarget)-InStrRev(sTarget,"\"))
	End If 
Else
	s_Log INFORMATION, "[Main Code] Excluded VFS: " & sTargetVFS
End If 

s_DelLog()

Set oFso = Nothing
Set oShell = Nothing

'***************************************************************************************************************************
'                                                   FUNCTION
'***************************************************************************************************************************

Function f_CreateFolder(s)
'************************************************************************
' Purpose : Create a folder, or a subset of folders based upon one path. 
'           Support both path and unc path. Ex : \\fqdn\share\my\path or 
'           D:\share\my\path. If only \\fqdn\share or D:\Share exists, 
'           function loop folder creation until path provided is created.
' Input   : String Path to folder
' Return  : True if folder exists or successfully created
'************************************************************************

Dim sUnc,sResult
	
	On Error Resume Next
	
	Dim sFolder
	
	If Right(s, 1) <> "\" Then
		s = s & "\"
	End If
	
	'Check if path is UNC replace base path \\server.fqdn\something with \
	If Left(s, 2) = "\\" Then
		s_Log INFORMATION, "[Function f_CreateFolder] UNC Path : " & s
		sUNC = s
		Set oRegEx = New RegExp
		oRegEx.Pattern = "\\\\[A-Za-z0-9.]+\\\w+\$?\\"
		sResult = oRegEx.Replace (s, "")
		s_Log INFORMATION, "[Function f_CreateFolder] UNC stripped, result : " & sResult
		sUnc = Left(s, Len(s) - Len(sResult))
		sFolder = sUnc
	End If
	
	s_Log INFORMATION, "[Function f_CreateFolder] Start creating directory structure : " & s
	
	Do Until sFolder = s
		sFolder = Left(s, InStr(Len(sFolder) + 1, s, "\"))
			s_Log INFORMATION, "[Function f_CreateFolder] Checking if folder exists : " & sFolder
			If Not oFso.FolderExists(sFolder) Then
				s_Log INFORMATION, "[Function f_CreateFolder] Creating folder : " & sFolder
				ofso.CreateFolder(sFolder)
				If err.number <> 0 Then
					s_Log ERRORL, "[Function f_CreateFolder] Error creating : " & sFolder & ". The error was : " & err.description
					Exit Function
				End If
			End If
	Loop

	If Right(s, 1) = "\" Then
		s = Left(s, Len(s) -1)
	End If

	f_CreateFolder = True
	
End Function

Function f_FileExists(s, bRequired)
'*******************************************************
' Purpose : Verify presense of a file, abort the script
'           if the file is not present and it's required
' Input   : s (String) Path to file
'           bRequired (Boolan) True|False
' Return  : True|False Boolean
'*******************************************************

	If (oFso.FileExists(s)) Then
		s_Log SUCCESS, "[f_FileExists] The file : " & s & " is present."
		f_FileExists = True
	Else
		f_FileExists = False
	End If
	
	If bRequired And f_FileExists = False Then
		s_Log ERRORL, "[f_FileExists] The file : " & s & " is NOT present."
		s_Log ERRORL, "[f_FileExists] The file : " & s & " is required for futher processing of this script."
		s_Log ERRORL, "[f_FileExists] " & ABORT
		wscript.quit
	End If
End Function

Function f_GetDayTimeDate()
'****************************************************
' Purpose : Get Day,Date,Time
' Input   : None
' Return  : Current day of week + Date + Time
'****************************************************
	
	f_GetDayTimeDate = WeekDayName(Weekday(Now, vbUseSystemDayOfWeek),,vbUseSystemDayOfWeek) & " " & Date & " "
	
	If CInt(Hour(Now)) < 10 Then
		f_GetDayTimeDate = f_GetDayTimeDate & "0" & Hour(Now)
	Else
		f_GetDayTimeDate = f_GetDayTimeDate & Hour(Now)
	End If
	
	If CInt(Minute(Now)) < 10 Then
		f_GetDayTimeDate = f_GetDayTimeDate & "0" & Minute(Now)
	Else
		f_GetDayTimeDate = f_GetDayTimeDate & Minute(Now)
	End If
	
	If InStr(f_GetDayTimeDate, "/") Then
		f_GetDayTimeDate = Replace(f_GetDayTimeDate, "/", ".")
	End If
	
	If InStr(f_GetDayTimeDate, "\") Then
		f_GetDayTimeDate = Replace(f_GetDayTimeDate, "\", ".")
	End If
	
End Function

Function f_Randomize(i)
'**************************************************
' Purpose : Create a random integer between 0 and i
' Input   : i (Integer)
' Return  : Random number between 0 and Input (i)
'**************************************************
  
  Dim iInt
  
  iInt = i
  
  s_Log INFORMATION, "[f_Randomize] Creating a random integer between : 0-" & iInt

  Randomize
  iInt = Int(i * Rnd)
  
  s_Log INFORMATION, "[f_Randomize] Random integer is : " & iInt
  
  f_Randomize = iInt
  
End Function

Function f_VerifyCmd(s)
'**************************************************************
' Purpose : Verify integrity of user input, assign each part of
'           command to system variables
' Input   : s (String) Command from FTPD
' Return  : True|False (Boolean)
'**************************************************************
	
	'Simple verify that a natural FTPD process is passing the command
	If Not LCase(Left(s, Len(SITECMD))) = SITECMD Then
		s_Log ERRORL, "[f_VerifyCmd] FTPD or this installation has been tamper with. Expected : " & SITECMD & " , Found : " & LCase(Left(s, Len(SITECMD)))
		f_VerifyCmd = False
		Exit Function
	End If
	
	'Removing verified SITECMD from beginning of string
	s = Right(s, Len(s)-Len(SITECMD))
	
	'Show help if requested
	If InStr(s, "-h") Or InStr(s, "help") Then
		s_Log SUCCESS, "[f_VerifyCmd] The user has requested help"
		s_TerminateInHlp()
		Exit Function
	'If string is empty, correct command is initiated
	ElseIf s = "" Then
	  s_Log SUCCESS, "[f_VerifyCmd] The integrity of command is verified successfully"
	  f_VerifyCmd = True
	End If

End Function

Function f_GetTempFilename()
	'**********************************************************************************
	' Purpose : Generate e temporary file, 
	' Inputs : None
	' Output : StringArray  : ShellRun : the actual output if any
	'**********************************************************************************
	Dim currentSub : currentSub = "GetTempFilename"
	
	f_GetTempFilename = oShell.ExpandEnvironmentStrings("%temp%") & oFso.GetTempName
End Function

Function f_ShellRun(sCmd, iWinStyle, bWait, sWorkDir)
	'**********************************************************************************
	' Purpose : Execute a command, It will then execute the command in a shell, 
	'           and capture the output into a file. That file is then read in and its 
	'           contents are returned as an Array() in the value the function returns.
	' Inputs : String : sCmd : The command to execute
	'		   Integer: iWinStyle : the window style (check VBS help for values)
	'		   Bool   : bWait : Wait for execution complete and return the output
	' Output : Array  : ShellRun : the actual output if any
	'**********************************************************************************
	Dim currentSub : currentSub = "ShellRun"
	
	Dim sCmdOnly, sCmdPath, sCmdDrive, sCmdWorkDir
	Dim COMSPEC : COMSPEC = "%comspec% /c "
	Dim sTempFile, cmdOutput
	
			
	sTempFile = f_GetTempFilename()
	On Error Resume Next 
		
	s_Log Information, "[" & currentSub & "] Command is : ["  & sCmd  & "]" & " and Work dir is: " & sWorkDir
	
	'Switch the current dir to sWorkDir or Default to command exe dir
	If sWorkDir <> vbNullString Then
		sCmdWorkDir = sWorkDir
	Else
		'Build the %comspec% to set drive and work directory
		If InStr(sCmd,Chr(34)) = 1 Then 'command is quoted
			sCmdOnly = Left(sCmd, InStr(2,sCmd,Chr(34)))
			sCmdOnly = Replace(sCmdOnly,Chr(34),vbNullString)
		Else
			sCmdOnly = Left(sCmd, InStr(2,sCmd,Chr(32)))
			sCmdOnly = Replace(sCmdOnly,Chr(32),vbNullString)
		End If 	
		sCmdWorkDir = Left(sCmdOnly, InStrRev(sCmdOnly,"\")-1)
	End If
	
	'Build the COMSPEC
	If InStr(sCmdWorkDir,":") = 2 Then 
		'extract drive info
		sCmdDrive = Left(sCmdWorkDir, InStr(sCmdWorkDir,":"))
		COMSPEC = COMSPEC & sCmdDrive & " " & chr(38) & " "
		'extract Path info
		sCmdpath = sCmdWorkDir
		If InStr(sCmdPath,Chr(32)) > 0 Then
			sCmdPath = Chr(34) & sCmdPath & Chr(34)
		End if
		COMSPEC = COMSPEC & "cd " & sCmdPath & " " & chr(38) & " "
	End If 
			
	If bWait Then
		oShell.Run COMSPEC &  sCmd  & " > " & sTempFile, iWinStyle, true
		s_Log SUCCESS, "[" & currentSub & "] Command Execute (Wait): [" & COMSPEC & sCmd  & " > " & sTempFile & "]"
		If f_FileExists(sTempFile,False) Then
			cmdOutput = Split(oFso.OpenTextFile(sTempFile,1).ReadAll,vbCRLF)
			If Err.Number = 62 Then
				s_Log WARNING, "[" & currentSub & "] No Output result from Command Execute"
				'Clear error
				Err.Clear
			Else
				'Just Debug
				s_Log SUCCESS, "[" & currentSub & "] Command has Output."
				For iCnt = 0 To UBound(cmdOutput)
					s_Log INFORMATION, "[" & currentSub & "] -" & cmdOutput(iCnt)
				Next
			End If

			oFso.DeleteFile sTempFile, true
		Else
			s_Log WARNING, "[" & currentSub & "] No Output From Command Execute"
		End If  
		f_ShellRun = cmdOutput
	Else 
		oShell.Run COMSPEC & sCmd, iWinStyle, false
		s_Log SUCCESS, "[" & currentSub & "] Command Execute (No Wait): " & sCmd
		f_ShellRun = Array()
	End If 
	
	'Capture any error	
	If Err.Number <> 0 Then
		s_Log ERRORL, "["& currentSub & "] ERROR: Number:" &Err.Number & " : " & Err.Description
		'Clear error
		Err.clear
	End If
End Function

Function s_Validate(sStringToTest,aArray)
		'**********************************************************************************
		' Purpose : Check if the element is part of an array
		'**********************************************************************************
		Dim bFound: bFound = False
		Dim element
		
		If (IsArray(aArray)) Then
			For Each Element In aArray				
				If LCase(sStringToTest) = LCase(Element) Then
					bFound = True
					Exit For
				End If
			Next 
		End If
		Validate = bFound
	End Function 
'***************************************************************************************************************************
'                                                       SUB
'***************************************************************************************************************************

Sub s_CreateDynDB(sPath, sName)
'*********************************************************
' Purpose : Create a Locate32 database
' Input   : sPath (String) Path to the folder
'         : sName (String) Name of Locate32 database
'*********************************************************
	
	Dim sCMD
	
	s_Log INFORMATION, "[s_CreateDB] Creating Locate32 Database containing files from " & sPath & "\" & sName & ". with name : " & "DynDB-" & sName
	
  	'Make sure path exists
  	If (oFso.FolderExists(sPath & "\" & sName)) Then
  	
		If f_FileExists (sDBRoot & "\DynDb-" & sName & ".dbs", False) Then
			s_DeleteFile sDBRoot & "\DynDb-" & sName & ".dbs"
		End If
  	  		
  		'Executing Updtdb32.exe
  		sCmd = Chr(34) & UPDATEDB & Chr(34) & " -d " & Chr(34) & sDBRoot & "\DynDB-" & sName & ".dbs" & Chr(34) & " -L " & Chr(34) & sPath & Chr(34) & " -e" & Chr(34) & ".raidenftpd.acl" & Chr(34) & " -P" & Chr(34) & sName & Chr(34) & " -F"
  		s_Log INFORMATION, "[s_CreateDB] Executing : " & sCmd
  		If ENABLEHSTART Then
 			f_ShellRun HSTART & " /RUNAS /NOCONSOLE " & Chr(34) & sCmd & Chr(34), 0, True, ""
 		Else
 			f_ShellRun sCMD, 0, True, ""
 		End If 
  				  		
    Else
      s_Log WARNING, "[s_CreateDB] The path: " & sPath & "\" & sName & " does NOT exist. DynDb update is omitted for this path."
    End If
      
End Sub

Sub s_FileDeletePattern(strFilePath, strWildCard) 
		'**********************************************************************************
		' Purpose : Delete files matching a pattern
		' Params:  strFilePath   String, Holding the name of the folder to test 
		'          strWildCard   String, Holding the wildcard string used to compare the file name with. (eg. "*.vbs") 
		' Returns: FileName      if the filename matches the wildcard, otherwise vbnullstring
		'**********************************************************************************	  
        Dim currentSub : currentSub = "Class Helper:FileDeletePattern"
        Dim objRegExp, strPattern, folder, item
        
        Set objRegExp = CreateObject("VBScript.RegExp") 
        
        On Error Resume next 
        ' Update the wildcard string to define a valid regular expression 
        strPattern = Replace(strWildCard, "[", "\[")
        strPattern = Replace(strPattern, "]", "\]")
        strPattern = Replace(strPattern, "{", "\{")
        strPattern = Replace(strPattern, "}", "\}")
        strPattern = Replace(strPattern, "(", "\(")
        strPattern = Replace(strPattern, ")", "\)")
        strPattern = Replace(strPattern, "+", "\+")
        strPattern = Replace(strPattern, "?", "\?")
        strPattern = Replace(strPattern, ".", "\.") 
        strPattern = Replace(strPattern, "*", ".*") 
        strPattern = "^" & strPattern & "$" 
         
        With objRegExp 
                .Pattern = strPattern 
                .IgnoreCase = True 
                .Global = True 
        End With 
         
        'process the file collection
    	Set folder = oFso.GetFolder(strFilePath)
	    
	    If Err.number <> 0 Then
			s_Log ERRORL, "["& currentSub & "] ERROR: Number:" &Err.Number & " : " & Err.Description
			exit sub
		End If
	     
	    For Each item in Folder.Files      
    	     If objRegExp.Test(item.Name) = True Then
    	     	s_DeleteFile strFilePath & "\" & item.Name
    	        s_Log INFORMATION, "[" & currentSub & "] Deleted dynamic file: " & item.Name
    	    End If     
	    Next    

        Set objRegExp = Nothing 
	End sub 

Sub s_DeleteFile(s)
'*************************************
' Purpose : Delete file
' Input   : String (s) path to file
'************************************
	On Error Resume Next
	
	err.clear
	
	oFso.DeleteFile s, True
	
	If err.number <> 0 Then
		s_Log ERRORL, "[s_DeleteFile] Failed to delete File : " & s & ". The error was : " & err.description & " (" & err.number & ")"
	Else
		s_Log SUCCESS, "[s_DeleteFile] File : " & s & " was successfully deleted."
	End If

End Sub

Sub s_DelLog()
'*********************************************
' Purpose : Delete obsolete logs, this routine
' Input   : None
'*********************************************

  If LOGS <> 0 Then
  	s_Log INFORMATION, "[Main Code] Call s_KeepOnlyFiles " & sLogRoot & " " & LOGS
  	s_KeepOnlyFiles sLogRoot, LOGS
  End If
  
  s_Log SUCCESS, "[Main Code] " & APPNAME & " " & APPVERMAJOR &  "." & APPVERMINOR & " ended successfully"

End Sub

Sub s_EventLog(i, s)
'*************************************************************
' Purpose : Write Event to Eventlog.
'           EventLog Level 0 = None 1 = Success/Error 2 = Full
' Input   : i : Event type, Integer
'               0 SUCCESS
'               1 ERROR (Const ERRORL)
'               2 WARNING
'               4 INFORMATION
'           s : Log message, String
'*************************************************************
'Const SUCCESS           = 0
'Const ERRORL            = 1
'Const WARNING           = 2
'Const INFORMATION       = 4
'0 = None 1 = Success/Error 2 = Full


	Select Case EVENTLOG
		Case 1
			Select Case i
				Case SUCCESS
					oShell.LogEvent i, s
				Case ERRORL
					oShell.LogEvent i, s
				Case Else
					Exit Sub
			End Select
		Case 2
			Select Case i
				Case SUCCESS
					oShell.LogEvent i, s
				Case ERRORL
					oShell.LogEvent i, s
				Case WARNING
					oShell.LogEvent i, s
				Case INFORMATION
					oShell.LogEvent i, s
				Case Else
					Exit Sub
			End Select
		Case 3
			Select Case i
				Case SUCCESS
					oShell.LogEvent i, s
				Case ERRORL
					oShell.LogEvent i, s
				Case WARNING
					oShell.LogEvent i, s
				Case INFORMATION
					oShell.LogEvent i, s
				Case Else
					Exit Sub
			End Select
		Case Else
			Exit Sub
	End Select

End Sub

Sub s_FileLog(i, s)
'*********************************************************************************************
' Purpose : Write Event to logfile. Build an array of events until path logfile is determined.
'           If logfile can not be written. Events are redirected to eventlog.
'           EventLog Level 0 = None 1 = Success/Error 2 = Full
' Input   : i : Event type, Integer
'               0 SUCCESS
'               1 ERROR (Const ERRORL)
'               2 WARNING
'               4 INFORMATION
'           s : Log message, String
' Use     : bLog Boolean True|False when actually start logging to file
'*********************************************************************************************
'Const SUCCESS           = 0
'Const ERRORL            = 1
'Const WARNING           = 2
'Const INFORMATION       = 4
'0 = None 1 = Success/Error 2 = Full

On Error Resume Next

Dim iArr
Dim oLog


	'Make sure errorlevel 0
	err.clear
	
	'Log to file if bLog flag is true
	If bLog = True Then
		
		Set oLog = oFso.OpenTextFile(sLog, FORAPPENDING, True)
		
		If err.number <> 0 Then
			iErr = err.number
			'Clear error
			err.clear
			'Check if log folder exists, try to create
			If f_CreateFolder(Left(sLog, InStrRev(sLog, "\"))) Then
				Set oLog = oFso.OpenTextFile(sLog, FORAPPENDING, True)
				
				Else
			
				'Abort filelog operation if can't be written, switch to EventLog	
				EVENTLOG = 2
				FILELOG = 0
				err.Raise = iErr
				s_Log ERRORL, "[Sub s_FileLog] Error occured while writing to logfile : " & sLog & ". The error was : " & err.description
				s_Log WARNING, "[Sub s_FileLog] Events will permanently be redirected to eventlog. All events occured prior to this warning will now be written."
				
				'Write events from array to eventlog
				If IsArray(aLog) AND aLog(0) <> "" Then
					For iArr = 0 To UBound(aLog)
						s_Log CInt(Left(aLog(iArr), 1)), Right(aLog(iArr), Len(aLog(iArr)) - 1)
					Next
					
					ReDim aLog(0)	
				End If
				
				Exit Sub
			End If
		End If
		
		'Write events from array to logfile
		If IsArray(aLog) AND aLog(0) <> "" Then
			For iArr = 0 To UBound(aLog)
				oLog.WriteLine Right(aLog(iArr), Len(aLog(iArr)) - 1)
			Next

			ReDim aLog(0)
		End If
		
		Select Case FILELOG
			Case 1
				Select Case i
					Case SUCCESS
						oLog.WriteLine Now & " SUCCESS    " & s
					Case ERRORL
						oLog.WriteLine Now & " ERROR      " & s
					Case Else
						Exit Sub
				End Select
			Case 2
				Select Case i
					Case SUCCESS
						oLog.WriteLine Now & " SUCCESS     " & s
					Case ERRORL
						oLog.WriteLine Now & " ERROR       " & s
					Case WARNING
						oLog.WriteLine Now & " WARNING     " & s
					Case INFORMATION
						oLog.WriteLine Now & " INFORMATION " & s
					Case Else
						Exit Sub
				End Select
			Case 3
				Select Case i
					Case SUCCESS
						oLog.WriteLine Now & " SUCCESS     " & s
					Case ERRORL
						oLog.WriteLine Now & " ERROR       " & s
					Case WARNING
						oLog.WriteLine Now & " WARNING     " & s
					Case INFORMATION
						oLog.WriteLine Now & " INFORMATION " & s
					Case Else
						Exit Sub
				End Select
			Case Else
				Exit Sub
		End Select
		
		oLog.close
		Set oLog = Nothing
	Else
		
		'Log to array while path to logfile determined
		If IsArray(aLog) Then
			iArr = UBound(aLog) + 1
			ReDim Preserve aLog(iArr)
		Else
			ReDim aLog(1)
		End If
		
		Select Case FILELOG
			Case 1
				Select Case i
					Case SUCCESS
						ReDim Preserve aLog(iArr)
						aLog(iArr) = i & Now & " SUCCESS " & s
					Case ERRORL
						ReDim Preserve aLog(iArr)
						aLog(iArr) = i & Now & " ERROR " & s
					Case Else
						Exit Sub
				End Select
			Case 2
				Select Case i
					Case SUCCESS
						ReDim Preserve aLog(iArr)
						aLog(iArr) = i & Now & " SUCCESS     " & s
					Case ERRORL
						ReDim Preserve aLog(iArr)
						aLog(iArr) = i & Now & " ERROR       " & s
					Case WARNING
						ReDim Preserve aLog(iArr)
						aLog(iArr) = i & Now & " WARNING     " & s
					Case INFORMATION
						ReDim Preserve aLog(iArr)
						aLog(iArr) = i & Now & " INFORMATION " & s
					Case Else
						Exit Sub
				End Select
			Case 3
				Select Case i
					Case SUCCESS
						ReDim Preserve aLog(iArr)
						aLog(iArr) = i & Now & " SUCCESS     " & s
					Case ERRORL
						ReDim Preserve aLog(iArr)
						aLog(iArr) = i & Now & " ERROR       " & s
					Case WARNING
						ReDim Preserve aLog(iArr)
						aLog(iArr) = i & Now & " WARNING     " & s
					Case INFORMATION
						ReDim Preserve aLog(iArr)
						aLog(iArr) = i & Now & " INFORMATION " & s
					Case Else
						Exit Sub
				End Select

			Case Else
				Exit Sub
		End Select
		
	End If

End Sub

Sub s_GetPathToIndexFromVFS(s)
'******************************************************************
' Purpose : Parse FTPD Virtual File System, get all available
'           paths, and populate these into array "aIndex"
' Input   : s (String) Path to VFS to parse
'******************************************************************

	Dim oVfs, aExcludedVFS, sExcludedVFS, bAllowed
	
	s_Log INFORMATION, "[s_GetPathToIndexFromVFS] Reading Virtual File System from " & s & ",  in to array"
	
	'Open Virtual File System
	Set oVfs = oFso.OpenTextFile(s, FORREADING)

	iCnt = 0

	'Read Virtual File System, parsing lines
	Do Until oVfs.AtEndOfStream
		sLine = oVfs.ReadLine
		
'		'Skip if line is root
'		If Mid(sLine, InStr(sLine, "|"), 3) = "|/|" Then
'			s_Log INFORMATION, "[s_GetPathToIndexFromVFS] " & sLine & " is FTP Root... Line is skipped"
		
		'Skip if line contain FTPD specific variables (Ex : Personal home folder)
		If InStr(sLine, "%") Then
			s_Log INFORMATION, "[s_GetPathToIndexFromVFS] " & sLine & " Contain FTPD variables... Line is skipped"
		
		'Processing lines containing path valid to index
		Else
			s_Log INFORMATION, "[s_GetPathToIndexFromVFS] " & sLine & " is valid, parsing..."
			bAllowed = True
			
			
			'Check Excluded VFS
			aExcludedVFS = Split(EXCLUDEDVFS, "|")
			For Each sExcludedVFS In aExcludedVFS
				If InStr(LCase(Split(sLine,"|")(1)), LCase(sExcludedVFS)) Then
					bAllowed = False  
				End If
			Next 
		
			If bAllowed Then
				ReDim Preserve aIndex(iCnt)

				aIndex(iCnt) = Left(sLine, InStr(sLine, "|") -1)
			
				s_Log INFORMATION, "[s_GetPathToIndexFromVFS] Index entry added to array : " & aIndex(iCnt)
									
				iCnt = iCnt + 1
			Else
				s_Log INFORMATION, "[s_GetPathToIndexFromVFS] Excluded: " & Split(sLine,"|")(1)
			
			End If 
		End If
		
	Loop

End Sub
Sub s_KeepOnlyFiles(s, i)
'*************************************************
' Purpose : Delete obsolete files based upon date.
'           n newest files are kept.
' Input   : String (s) Path to root of files
'           Integer (i) Number of folders to keep
'*************************************************
	On Error Resume Next
	
	Dim aDate
'	Dim oFldr,oFile
'	Dim cFiles
'	Dim iCnt
	Dim n,m,temp
	
	Set oFldr = oFso.GetFolder(s)
	
	If err.number <> 0 Then
		s_Log ERRORL, "[s_KeepOnlyFiles] An Error occured connecting to : " & s & " old files must be deleted manually."
		Exit Sub
	Else
		s_Log INFORMATION, "[s_KeepOnlyFiles] Connected to : " & s
	End If
	
	Set cFiles = oFldr.Files
	
	If err.number <> 0 Then
		s_Log ERRORL, "[s_KeepOnlyFiles] An Error occured while listing files in folder : " & s & ". Old files must be deleted manually."
		Exit Sub
	Else
		s_Log INFORMATION, "[s_KeepOnlyFiles] Succsessfully listed files in folder : " & s
	End If
	
	'Check if number of files greater than i
	If cFiles.Count <= i Then
		s_Log INFORMATION, "[s_KeepOnlyFiles] Number of file(s) in root is : " & cFiles.Count & ". Number is less or equal to : " & i & " which is the number of file(s) to keep."
		Exit Sub
	End If
		
	s_Log INFORMATION, "[s_KeepOnlyFiles] Number of files in root is : " & cFiles.Count & ". Number is greater : " & i & " which is the number of file(s) to keep."
	
	'ReDim array to number of folders
	ReDim aDate(cFiles.Count -1)
	
	s_Log INFORMATION, "[s_KeepOnlyFiles] Creating array with fixed size : " & cFiles.Count -1 & ". Adding date of folders to array"
	
	iCnt = 0
	
	'Add date creation of all folders to array
	For Each oFile in cFiles
		s_Log INFORMATION, "[s_KeepOnlyFiles] aDate(" & iCnt & ") = " & oFile.DateCreated & " (Path : " & oFile.Path & ")"
		aDate(iCnt) = oFile.DateCreated
		iCnt = iCnt + 1
	Next
	
	'Sorting array by date, ascent sort order (The famous bubble sort)
	s_Log INFORMATION, "[s_KeepOnlyFiles] Sorting dates in array, ascent sort order"
	For n = 0 to UBound(aDate) -1 
		For m = n+1 to UBound(aDate) 
			If aDate(m) < aDate(n) Then
				temp = aDate(m)
				aDate(m) = aDate(n)
				aDate(n) = temp
			End If
		Next
	Next
	
	'Just logging
	s_Log INFORMATION, "[s_KeepOnlyFiles] Array sorted, result in ascent order : "
	For iCnt = 0 To UBound(aDate)
		s_Log INFORMATION, "[s_KeepOnlyFiles] aDate(" & iCnt & ") = " & aDate(iCnt)
	Next
			
	
	
	'Cut array, keep (i) rows with date of folders which is going to be deleted
	ReDim Preserve aDate(UBound(aDate) -i)
	s_Log INFORMATION, "[s_KeepOnlyFiles] Array aDate cut, remaing rows are : "
	
	'Even more logging (those debuggers ;))
	For iCnt = 0 To UBound(aDate)
		s_Log INFORMATION, "[s_KeepOnlyFiles] aDate(" & iCnt & ") = " & aDate(iCnt)
	Next
	
	s_Log INFORMATION, "[s_KeepOnlyFiles] Start deleting file(s)..."
	
	For Each oFile in cFiles
		For iCnt = 0 To UBound(aDate)
			If oFile.DateCreated = aDate(iCnt) Then
				s_Log INFORMATION, "[s_KeepOnlyFiles] aDate(" & iCnt & ") = " & aDate(iCnt) & " matches DateCreated on file : " & oFile.Path & " (Date=" & oFile.DateCreated & ")"
				s_DeleteFile oFile.Path
				Exit For
			End If
		Next
	Next
End Sub

Sub s_Log(i, s)
'***********************************************************************************************
' Purpose : Log interface, write various type of events to different formats, NT Event, File etc
'           Easily extend logging into other formats, Ex : Syslog, mail, xml etc.
' Input   : i : Event type, Integer 0 = None 1 = Success/Error 2 = Full
'           s : Log message, String
'***********************************************************************************************
	
	'Eventlog output
	If EVENTLOG = 1 or EVENTLOG = 2 Then
		Set oRegEx = New RegExp
		oRegEx.Pattern = "\[.*\] "
		s = oRegEx.Replace (s, "")
		s_EventLog i, s
		Set oRegEx = Nothing
	End If
	
	'Debug EventLog output
	If EVENTLOG = 3 Then
		s_EventLog i, s
	End If

	'Logfile output
	If FILELOG = 1 or FILELOG = 2 Then
		Set oRegEx = New RegExp
		oRegEx.Pattern = "\[.*\] "
		s = oRegEx.Replace (s, "")
		s_FileLog i, s
		Set oRegEx = Nothing
	End If
	
	'Debug logfile output
	If FILELOG = 3 Then
		s_FileLog i, s
	End If	
	
	'Debug screen output
	If FILELOG = 3 or EVENTLOG = 3 Then
		wscript.echo s
	End If
	
End Sub

Sub Import (sFileName)
	'**********************************************************************************
	' Purpose : Import external file
	'**********************************************************************************
	Dim oFso, oFile
	Dim sScriptDir, sFilePath, sStreamData
	
	Set oFso		= CreateObject("Scripting.FileSystemObject")
	sScriptDir = oFso.GetParentFolderName(WScript.ScriptFullName)   
	sFilePath = oFso.BuildPath(sScriptDir,sFileName)   
	Const ForReading = 1   
	
	Set oFile = oFso.OpenTextFile(sFilePath,ForReading)   
	sStreamData = oFile.ReadAll()   
	ExecuteGlobal sStreamData   
End Sub